'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 10 April 1995 at 5:42:07 pm'!

!ClassOrganizer methodsFor: 'categories'!

renameCategory: oldName to: newName
	"Attempt to rename the existing category named oldName to newName. 
	Answer whether successful (there was a category named oldName and there 
	wasn't already a category named newName)."

	| i symbol |
	i := categoryArray indexOf: oldName ifAbsent: [^false].
	symbol := newName asSymbol.
	categoryArray indexOf: symbol
		ifAbsent: [categoryArray at: i put: symbol.
				self class == ClassOrganizer
					ifTrue: [self applicationManagement
								renameProtocol: oldName
								to: newName
								class: self myClass asSymbol]
					ifFalse: [self applicationManagement
								renameCategory: oldName
								to: newName].
				  ^true].
	^false  "newName was already there"! !