' .ApplicationSource X_Interface(1.8)'!
'From VisualWorks(R) Release 2.0 of 4 August 1994 on 7 April 1995 at 4:47:32 pm'!



"return the result of activateSelection"!

!ListController methodsFor: 'private'!

doubleClickAt: aPoint 
	"select the element at aPoint if necessary, then perform doubleClick 
	activity"

	| index oldSelection |
	view isEmpty ifTrue: [^nil]. 
	(index := self view findSelection: aPoint) == nil ifTrue: [^nil].
	(oldSelection := view selection) = index
		ifFalse: 
			[view moveSelectionBox: index.
			self changeSelectionFrom: oldSelection to: index.
			view selection = oldSelection ifTrue: [^self	"change request failed"]].
	^self activateSelection! !

"bug fix: Collections with texts were not properly handled
	(sorting is provided automatically now)"!

!Collection methodsFor: 'user interface'!

 !                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       


' .ApplicationSource X_Interface(1.9)'!
'From VisualWorks(R) Release 2.0 of 4 August 1994 on 12 April 1995 at 4:13:27 pm'!



Collection removeSelector: #selectFromUser!

!Collection methodsFor: 'user interface'!

selectFromUser: prompt sort: aBoolean ifEmpty: aBlock 
	"open a menu with receivers' elements as items (sort them if aBoolean is true); 
	return the element the user selects, evaluate aBlock if nothing is selected"

	| sequence strings isSorted sorted selection |
	self isEmpty
		ifTrue: 
			[DialogView warn: 'Nobody'.
			^aBlock value].
	sequence := self isSequenceable
				ifTrue: [self]
				ifFalse: [self asOrderedCollection].
	strings := (sequence first isString or: [sequence first class == Text])
				ifTrue: [sequence]
				ifFalse: [sequence collect: [:each | each printString]].
	sorted := (isSorted := aBoolean not or: [strings isKindOf: SortedCollection])
				ifTrue: [strings]
				ifFalse: [strings asSortedCollection].
	selection := Dialog
				choose: prompt
				fromList: sorted
				values: (isSorted ifTrue: [sequence] ifFalse: [sorted])
				lines: 20
				cancel: [^aBlock value].
	^isSorted
		ifTrue: [selection]
		ifFalse: [sequence at: (strings indexOf: selection)]! !

!Collection methodsFor: 'user interface'!

selectFromUser: prompt ifEmpty: aBlock 
	^self
		selectFromUser: prompt
		sort: self isSequenceable not
		ifEmpty: aBlock! !

!Collection methodsFor: 'user interface'!

select: prompt fromUserIfEmpty: aBlock 
	"backward compatibility"

	^self selectFromUser: prompt ifEmpty: aBlock! !