
' .ApplicationSource GemStoneDummy(1.0)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 10 March 1994 at 11:24:17 pm'!



'- installation of GemStoneDummy(1.0) -'!

"install the default compiler as GemStone compiler as long as it is not present itself"

Smalltalk at: #GSCompiler
	ifAbsent: [Smalltalk at: #GSCompiler put: Object compilerClass]!

'- sources of GemStoneDummy(1.0) -'!

!Object methodsFor: 'gemstone support'!

makeGSTransparent!

markDirtyOnInstvarAssign! !



Object subclass: #GSI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GemStone Proxies'!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!GSI class methodsFor: 'accessing'!

addGlobalConnector: aGSNameConnector! !



Object subclass: #GSNameConnector
	instanceVariableNames: 'stName gsName forward '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GemStone Proxies'!


!GSNameConnector methodsFor: 'forwarding'!

beForwarderOnConnect
	forward := true! !

!GSNameConnector methodsFor: 'initialize-release'!

stName: localKeySymbol gsName: remoteKeySymbol 
	"initialize the receiver with the given names; begin with non-forwarding mode"

	stName := localKeySymbol.
	gsName := remoteKeySymbol.
	forward := false! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!GSNameConnector class methodsFor: 'instance creation'!

stName: localKeySymbol gsName: remoteKeySymbol
	"create an alias for an object of a Smalltalk client"

	^self new stName: localKeySymbol gsName: remoteKeySymbol! !



!Character methodsFor: 'printing'!

printOn: aStream  
	"Append to the argument aStream a sequence of characters preceded by the
	literal $ that identifies the receiver."
	"code has been changed for demo purpose, although it is an optimization"

	aStream nextPut: $$; nextPut: self! !

