' .ApplicationSource APL-SystemLink(1.5)'!
'From VisualWorks(R) Release 2.0 of 4 August 1994 on 3 March 1995 at 5:35:03 pm'!



"fix: release files if running short of handles"!

!IOAccessor class methodsFor: 'utilities'!

releaseFiles
	"request file consuming applications/objects to release files they do not need;
	return true/false to indicate success"
	"IOAccessor releaseFiles"

	^self applicationManagement releaseSourceFiles! !

!IOAccessor class methodsFor: 'instance creation'!

openFileNamed: nm direction: rwMode creation: creationRule 
	"Return an accessor on the file named (a String or Filename) with 
	the appropriate read/write mode. 
	try to release files if we are running short of handles"

	^OSErrorHolder noResourcesSignal handle: [:ex | self releaseFiles
			ifTrue: [ex restart]
			ifFalse: [ex reject]]
		do: [self defaultForFiles handleValue: [nm asFilename openHandleForDirection: rwMode creation: creationRule]]! !