' .ApplicationSource X_Interface(1.5)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 7 April 1995 at 3:49:27 pm'!



"return the result of activateSelection"!

!ListController methodsFor: 'private'!

doubleClickAt: aPoint 
	"select the element at aPoint if necessary, then perform doubleClick 
	activity"

	| index oldSelection |
	view isEmpty ifTrue: [^nil]. 
	(index := self view findSelection: aPoint) == nil ifTrue: [^nil].
	(oldSelection := view selection) = index
		ifFalse: 
			[view moveSelectionBox: index.
			self changeSelectionFrom: oldSelection to: index.
			view selection = oldSelection ifTrue: [^self	"change request failed"]].
	^self activateSelection! !

"bug fix: Collections with texts were not properly handled
	(sorting is provided automatically now)"!

!Collection methodsFor: 'user interface'!

 !                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     


' .ApplicationSource X_Interface(1.6)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 12 April 1995 at 1:07:51 pm'!



Collection removeSelector: #selectFromUser!

!Collection methodsFor: 'user interface'!

selectFromUser: prompt sort: aBoolean ifEmpty: aBlock 
	"open a menu with receivers' elements as items (sort them if aBoolean is true); 
	return the element the user selects, evaluate aBlock if nothing is selected"

	| sequence strings isSorted sorted selection |
	self isEmpty
		ifTrue: 
			[DialogView warn: 'Nobody'.
			^aBlock value].
	sequence := self isSequenceable
				ifTrue: [self]
				ifFalse: [self asOrderedCollection].
	strings := (sequence first isString or: [sequence first class == Text])
				ifTrue: [sequence]
				ifFalse: [sequence collect: [:each | each printString]].
	sorted := (isSorted := aBoolean not or: [strings isKindOf: SortedCollection])
				ifTrue: [strings]
				ifFalse: [strings asSortedCollection].
	selection := PopUpMenu labelList: (Array with: sorted).
	selection := prompt isEmpty
				ifTrue: [selection startUp]
				ifFalse: [selection startUpWithHeading: prompt].
	^selection == 0
		ifTrue: [aBlock value]
		ifFalse: 
			[isSorted ifFalse: [selection := strings indexOf: (sorted at: selection)].
			sequence at: selection]! !

!Collection methodsFor: 'user interface'!

selectFromUser: prompt ifEmpty: aBlock 
	^self
		selectFromUser: prompt
		sort: self isSequenceable not
		ifEmpty: aBlock! !

!Collection methodsFor: 'user interface'!

select: prompt fromUserIfEmpty: aBlock 
	"backward compatibility"

	^self selectFromUser: prompt ifEmpty: aBlock! !