' .ApplicationSource BASE(1.7)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 10 April 1995 at 1:43:31 pm'!



!CharacterArray methodsFor: 'converting'!

withArgs: collectionOrString andCRs: aBoolean
	"mode 1: replace nth % by nth element in collectionOrString 
	mode 2: replace %n (n from [1..9]) by nth element in collectionOrString
	mode 1 and 2 must not be mixed up; suppress replacement by specifying %%;
	replace occurrences of $\ with CR (if aBoolean is true)
	(convenience: if collectionOrString is string treat it as array with the string)"

	| args msg tmp ch printArg nxtArg |
	args := collectionOrString isString ifTrue: [Array with: collectionOrString] ifFalse: [collectionOrString].
	msg := WriteStream on: (String new: 200).
	tmp := self readStream.
	printArg := 
		[:idx | | arg |
		arg := args at: idx.
		Object messageNotUnderstoodSignal handle: [:ex | ex restartDo: [msg print: arg]] from: arg
			do: [msg nextPutAll: arg asString]].
	nxtArg := 0.
	[(ch := tmp next) == nil]
		whileFalse: [ch == $%
				ifTrue: 
					[| idx |
					(idx := '123456789%' indexOf: (ch := tmp next) ifAbsent: [11]) < 10
						ifTrue: [printArg value: idx		"mode 2"]
						ifFalse: 
							[ch == $% ifFalse: [printArg value: (nxtArg := nxtArg + 1)	"mode 1"].
							ch == $\ & aBoolean
								ifTrue: [msg cr]
								ifFalse: [ch == nil ifFalse: [msg nextPut: ch]]]]
				ifFalse: [ch == $\ & aBoolean
						ifTrue: [msg cr]
						ifFalse: [msg nextPut: ch]]].
	^msg contents! !

!CharacterArray methodsFor: 'converting'!

withArgs: collectionOrString 
	"replace % with arguments (see comment in #withArgs:andCRs:)"

	^self withArgs: collectionOrString andCRs: true! !

"get rid of an unnecessary polymorphism selector
(the only send was in Application> #sourceIdentifierForVersion:)"!

Character removeSelector: #asString!

Filename class removeSelector: #stringFromArray:!