' .ApplicationSource X_Changes(1.3)'!
'From Objectworks\Smalltalk(R), Release 4.1 of 15 April 1992 on 15 February 1995 at 7:40:31 pm'!



"optimization"!

!ChangeCompareView methodsFor: 'private'!

getContents
	"return the system source code for the currently selected change in 
	the underlying ChangeList (return '- same -' for textual identity);
	if advanced string comparison is present display the diff sections"

	| aChange sysText chgText comp |
	(aChange := model selectedChange) == nil ifTrue: [^Text new].
	(sysText := aChange systemSourceText) isEmpty ifTrue: [^sysText].
	sysText = (chgText := model value asText)
		ifTrue: [^' - same -' asText].

	comp := Smalltalk at: #MethodComparison ifAbsent:
			["there is no string comparison utility; give as much info as possible"
			^(model equalWithoutComments: sysText and: chgText)
				ifTrue: 
					[| insert |
					insert := '- equal without comment -\\' withCRs.
					(insert , sysText string) asText emphasizeFrom: 1 to: insert size with: #italic]
				ifFalse: [sysText]].

	"advanced string comparison"
	Cursor read showWhile:
		[comp emphasizeDiffsFor: (sysText := sysText asText) and: chgText].

	model setValue: chgText.
	"make the change list's code view redraw"
	"avoid infinite recursion, don't use: model changed: #listIndex."
	(model dependents detect: [:dep | dep class == ComposedTextView])
		editText: chgText; invalidate.

	"force sysText to be different from current displayContents"
	self editText: ''.
	^sysText! !

!ChangeCompareView methodsFor: 'updating'!

update: aSymbol 
	"react on text change of the model (aChangeList) announced by #value"

	aSymbol == #value ifTrue: [self updateDisplayContents]! !