'From VisualWorks(R) Release 2.0 of 4 August 1994 on 28 December 1994 at 1:19:16 pm'!



!Exception methodsFor: 'private'!

propagatePrivateFrom: startContext
	"Search for, and run, an appropriate handler.
	This is called both initially and after a reject.
	In the latter case, we don't reset firstUnwindContext."
	| handler ex2 result |
	handler := self findHandlerFrom: startContext.
	handler == nil ifTrue:
		[(Signal noHandlerSignal accepts: signal)
			ifTrue:
				["If this was already an unhandled exception
				exception that was rejected, just start the
				emergency handler--parameter is the exception
				that couldn't be handled originally"
				^EmergencyHandler value: parameter value: parameter initialContext]
			ifFalse:
				["No handler.  Convert this exception into an 'unhandled exception' exception"
				(ex2 := Signal noHandlerSignal newExceptionFrom: self originator)
					parameter: self.
				handler := ex2 findHandlerFrom: initialContext.
				handler == nil ifTrue:
					["No handler for this either.  Emergency!!"
					^EmergencyHandler value: self value: initialContext].
				result := handler value: ex2.
				"The handler returned without choosing an option."
				^ex2 noHandlerAction: result]].
	result := handler value: self.
	"The handler returned without choosing an option."
	^self noHandlerAction: result! !
